<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <title>Document</title>
</head>
<body onload="onLoadPaging()">
    <div class="container jumbotron">
        <h1 class="text-center">Danh sach nguoi dung dang ky</h1>
        <table id="user-table" class="table table-bordered table-hover table-striped">
            <thead>
                <tr>
                    <th>Ma nguoi dung</th>
                    <th>First name</th>
                    <th>Last name</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer type</th>
                    <th>Register status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <script>
        "use strict"
        //region1
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK =4
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users";
        const gEND_OF_ROW_COL = -1;
        //region2

        //region3
        //ham xu ly su kien loading
        function onLoadPaging(){
            //goi server
            var vXHTMLRequest = new XMLHttpRequest();
            callApiGetUsers(vXHTMLRequest);
            vXHTMLRequest.onreadystatechange = function(){
                if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                    //xu ly hien thi
                    showDataOnTable(vXHTMLRequest);
                    //gan su kien click cho nut chi tiet tung user
                    addListenerEventInforButton();
                }
            }   
        }
        //region4
        function callApiGetUsers(paramXmlHttp){
            "use strict";
            paramXmlHttp.open("GET",gBASE_URL,true);
            paramXmlHttp.send();
        }
        //load du lieu tu response server tra ve vao table, hien cac button chi tiet
        //input/start:
        //-paramXmlHttp: request da dung goi server tra ve responsetext co chua du lieu
        //output/end:
        //-du lieu hien thi tren bang
        //-cac button chi tiet duoc hien thi va co san du lieu dataset
        function showDataOnTable(paramXmlHttpUser){
            "use strict";
            console.log(paramXmlHttpUser.responseText);
            var vResponse = JSON.parse(paramXmlHttpUser.responseText);
            var vTable = document.getElementById("user-table");
            var vTableBody = vTable.getElementsByTagName("tbody")[0];
            for(var bI = 0; bI< vResponse.length; bI++){
                //tao dong moi cho bang va ghi vao cac gia tri
                var vNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
                var vCellMaNguoiDung = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellFirstName = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellLastName = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellCountry = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellSubject = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellCustomerType = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellRegisterStatus = vNewRow.insertCell(gEND_OF_ROW_COL);
                var vCellUserAction = vNewRow.insertCell(gEND_OF_ROW_COL);

                vCellMaNguoiDung.innerHTML = vResponse[bI].id;
                vCellFirstName.innerHTML = vResponse[bI].firstname;
                vCellLastName.innerHTML = vResponse[bI].lastname;
                vCellCountry.innerHTML = vResponse[bI].country;
                vCellSubject.innerHTML = vResponse[bI].subject;
                vCellCustomerType.innerHTML = vResponse[bI].customerType;
                vCellRegisterStatus.innerHTML = vResponse[bI].registerStatus;
                
                //button, chua data chi tiet cua loai data do tren tung dong
                var vDetailButton = document.createElement("button");
                vDetailButton.className = "info-user btn btn-info"; //bootstrap className cho button
                vDetailButton.setAttribute("data-id", vResponse[bI].id);
                vDetailButton.setAttribute("data-firstname", vResponse[bI].firstname);
                vDetailButton.setAttribute("data-lastname", vResponse[bI].lastname);
                vDetailButton.setAttribute("data-country", vResponse[bI].country);
                vDetailButton.setAttribute("data-subject", vResponse[bI].subject);
                vDetailButton.setAttribute("data-customer-type", vResponse[bI].customerType);
                vDetailButton.setAttribute("data-register-status", vResponse[bI].registerStatus);
                vDetailButton.innerHTML = "Chi tiet";
                vCellUserAction.appendChild(vDetailButton);
            }
        }

        //add listener cho event handler (event click)
        // khi an nut se goi cho function onBtnChiTietClick
        function addListenerEventInforButton(){
            //truy xuat tat ca cac nut detail qua className
            var vDetailButtons = document.getElementsByClassName("info-user");
            for(var bI = 0; bI<vDetailButtons.length; bI++){
                vDetailButtons[bI].addEventListener('click',function(){
                    onBtnChiTietClick(this);
                });
            }
        }

        //onBtnChiTietClick
        function onBtnChiTietClick(paramDetailButton){
            //thu thap du lieu
            var vUserID = paramDetailButton.dataset.id;
            var vFirstName = paramDetailButton.dataset.firstname;
            var vLastName = paramDetailButton.dataset.lastname;
            var vCountry = paramDetailButton.dataset.country;
            var vSubject = paramDetailButton.dataset.subject;
            var vCustomerType = paramDetailButton.dataset.customerType;
            var vRegisterStaus = paramDetailButton.dataset.registerStatus;

            console.log("thong tin user: ");
            console.log("User Id: ", vUserID);
            console.log("First name: ", vFirstName);
            console.log("Last name: ", vLastName);
            console.log("Country: ", vCountry);
            console.log("Subject: ", vSubject);
            console.log("Customer Type: ", vCustomerType);
            console.log("Register Status: ", vRegisterStaus);
        }
    </script>
</body>
</html>